''**************************************************************
''*  Putty Telnet Wireless WX Page Controls Servo Host Demo    *
''*  Author: Clock Loop @ parallax forums                      *
''*  Upload the webpage page-controls-servo.html to your WX    *
''*  Visit http://192.168.4.1/files/page-controls-servo.html   *
''*  I did not make the html, parallax did?                    *          
''**************************************************************


CON 
  _CLKMODE=XTAL1 + PLL16X                   ' The system clock spec
  _XINFREQ = 5_000_000                                  ' Crystal

  Rx        = 31     'serial in from wx device
  Tx        = 30     'serial out to wx device
  ServoPin  = 0

OBJ
    SERVO : "Servo32v7.spin"
    ser: "Parallax Serial Terminal.spin"

VAR
    byte   Angle, Handle, ReplyStatus
    long   Stack1[100]

Pub Main   

cognew(Comms, @Stack1)

Pub Comms | CommandMode, ServoPwm, ServoPwm1, ServoPwm2
  
  ServoPwm := 0
  ReplyStatus := 0  
  
  dira[TX]~~          ' Set direction to output
  outa[TX]:= 0        ' Set TX low.                         
  waitcnt(10_000_000 + cnt)   'wait 1/10 second for command mode to start in the module.
  dira[TX]~           ' Set direction to input  
  
  ser.StartRxTx(RX, TX, 0, 115200)   'Cog #2 
  waitcnt(10_000_000 + cnt)   'wait 1/10 second for serial to start.
  SERVO.Start                 ' Cog 3 Start servo handler  
  
                       
  ser.char(254)  'Begin marker
  ser.str(string("LISTEN:HTTP,/servo"))   'Tell the module to listen to a specific path on http port 80.
  ser.char(13)    'End marker     
  
  ser.str(string(27))     'Set ansi command mode in putty.
  ser.str(string("[2J"))  'Clear putty telnet screen. 
      
  ser.str(string(27))      'Set ansi command mode in putty.                 
  ser.str(string("[2;3f")) 'Set Position in putty.      
  ser.str(string("Prop Started")) 'Tell putty command mode is on.                       
  ser.str(string(27))      'Set ansi command mode in putty.      
  ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0        
  Repeat 10  ' wait 10 seconds to help determine if servo reset prop.
    waitcnt(80_000_000 + cnt)   'wait 1 second 
        
  Repeat                'The main repeat loop.
    ser.str(string(27))     'Set ansi command mode in putty.
    ser.str(string("[2J"))  'Clear putty telnet screen. 
    
    ser.str(string(27))      'Set ansi command mode in putty.                 
    ser.str(string("[2;3f")) 'Set Position in putty.      
    ser.str(string("Command Mode is On. ")) 'Tell putty command mode is on.                       
    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0

    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[4;3f")) 'Set Position in putty
                                                           
    If ReplyStatus == 1     
      ser.str(string("Good reply."))   'If last reply was good, put it back up on putty which was cleared.                
    Else
      ser.str(string("  No reply."))    'If last reply was bad, put it back up on putty which was cleared.   

    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[5;3f")) 'Set Position in putty to put cursor at 0 
    ser.str(string("Angle that the webpage sent: ")) '
    ser.dec(Angle)
    
    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[6;3f")) 'Set Position in putty
    ser.str(string("Calculate Pwm Output: ")) '
    ser.dec(ServoPwm)

    ser.str(string(27))      'Set ansi command mode in putty.                                               
    ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0

                              '           
    ReplyStatus := 0     'Set the reply to bad so it can recheck for a new reply.
      
    Reply[0] := 0  ' clear data
    Reply[1] := 0  ' clear data
    Reply[2] := 0  ' clear data
    Reply[3] := 0  ' clear data
    Reply[4] := 0  ' clear data
    Reply[5] := 0  ' clear data
    Reply[6] := 0  ' clear data
    Reply[7] := 0  ' clear data
      
    Repeat 10
        ser.rxflush
        ser.char(254)  'Begin marker
        ser.str(string("POLL:"))   'Tell the module to listen to a ANY protocol/path.
        ser.char(13)    'End marker
        waitcnt(10_000_000 + cnt) 'Wait for 1/10 s  Let buffer fill.
        Reply[0] := ser.rxcheck   ' should be 254
        Reply[1] := ser.rxcheck   ' should be =
        Reply[2] := ser.rxcheck   ' should be P
        Reply[3] := ser.rxcheck   ' should be ,
        Reply[4] := ser.rxcheck   ' should be 5 (this could change) The connection identifier to use for this request
        Reply[5] := ser.rxcheck   ' should be ,
        Reply[6] := ser.rxcheck   ' should be 1
        Reply[7] := ser.rxcheck   ' should be 13   
                                           
        
        If Reply[0] == 254 And Reply[1] == "=" And Reply[2] == "P" And Reply[7] == 13
            ReplyStatus := 1     'Set the reply to good so it can be shown in putty.
          
            Handle := Reply[4]  'Store connection identifier.
          
            Reply[0] := 0  ' clear data
            Reply[1] := 0  ' clear data
            Reply[2] := 0  ' clear data
            Reply[3] := 0  ' clear data
            Reply[4] := 0  ' clear data
            Reply[5] := 0  ' clear data
            Reply[6] := 0  ' clear data
            Reply[7] := 0  ' clear data                  
            
            ser.rxflush             
            ser.char(254)               'Begin marker
            ser.str(string("ARG:"))   'Retrieve HTTP GET/POST’s name argument (in query or body) on connection handle.
            ser.char(Handle)            'An active connection handle; returned by POLL
            ser.str(string(","))      'Required for a reply
            ser.str(string("angle"))  'The argument name to retrieve.   
            ser.char(13)                'End marker                                    
            waitcnt(10_000_000 + cnt) 'Wait for 1/10 s   Let buffer fill.
            Reply[0] := ser.rxcheck   ' should be 254
            Reply[1] := ser.rxcheck   ' should be =
            Reply[2] := ser.rxcheck   ' should be S
            Reply[3] := ser.rxcheck   ' should be ,
            Reply[4] := ser.rxcheck   ' should be argument value  (this could change) -1 no reply
            Reply[5] := ser.rxcheck   ' should be argument value  (this could change) -1 no reply. This could also be 13
            Reply[6] := ser.rxcheck   ' should be argument value  (this could change) -1 no reply. This could also be 13
            Reply[7] := ser.rxcheck   ' should be 13                                         
                    
            If Reply[0] == 254 And Reply[1] == "=" And Reply[2] == "S" 
              If Reply[5] == 13  'The end marker
                Reply[5] := 0    'Zero terminate the string so it can be converted to decimal.
              
              Elseif Reply[6] == 13  'The end marker
                Reply[6] := 0    'Zero terminate the string so it can be converted to decimal.
            
              Else                 'The end marker all other conditions the end marker is a byte 7
                Reply[7] := 0     'Zero terminate the string so it can be converted to decimal.        
              
              Angle := ser.StrToBase(@word[@Reply[4]], 10)  ' store and convert string angle in byte variable angle.
              ServoPwm1 := Angle + 30       'convert angle to pwm 
              ServoPwm2 := ServoPwm1 / 2  'convert angle to pwm 
              ServoPwm := 12 * ServoPwm1 + ServoPwm2  'convert angle to pwm 
                          
              SERVO.Set(ServoPin, ServoPwm) 'Set angle of servo.                               
              'BEWARE your PROP will restart if you change the servo pwm too fast.
              'Tie the servo ground close to the power supply, not near the prop.
              'Like as if the prop ground is on a different branch than the servo.                   
               
              ser.char(254)               'Begin marker
              ser.str(string("REPLY:")) 'Tell the module to send a reply to the poll response.
              ser.char(Handle)            'Should be a number.   An active connection handle; returned by POLL.
              ser.str(string(","))      'Required for a reply
              ser.str(string("200"))    'The desired HTTP response code for the reply.                         
              ser.str(string(","))      'Required for a reply
              ser.str(string("2"))      'Tell the module how many bytes? (or is this digits?) the reply is.
              ser.char(13)                'End marker               
              ser.str(string("OK"))     'Send OK to the webpage.
              ser.char(13)    'End marker                                 
              'waitcnt(80_000_000 + cnt) 'Wait for 1/2 s
DAT

Reply   byte  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0


{{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
}}   